SystemOrganization addCategory: #'SqueakNxt-Compiler-Api'!
SystemOrganization addCategory: #'SqueakNxt-Compiler-Programs'!
SystemOrganization addCategory: #'SqueakNxt-Compiler-Translators'!
SystemOrganization addCategory: #'SqueakNxt-Compiler-Output'!

CType subclass: #NxcType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-Compiler-Output'!

!NxcType methodsFor: 'as yet unclassified' stamp: 'Richo 10/13/2011 17:59'!
source
	"Nxc doesn't allow pointers"
	^ self name! !

CProgram subclass: #NXProgram
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-Compiler-Programs'!

NXProgram subclass: #DodgeWallExample
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-Compiler-Programs'!

!DodgeWallExample methodsFor: 'as yet unclassified' stamp: 'Richo 2/22/2011 18:22'!
main
	self setSensorLowSpeed: 3.
	[(self sensorUS: 3) < 30
		ifTrue: [self onFwd: 0 speed: 100.
				self onFwd: 2 speed: -100]
		ifFalse: [self onFwd: 0 speed: 100.
				self onFwd: 2 speed: 100]] repeat ! !

NXProgram subclass: #FollowLineExample
	instanceVariableNames: 'black'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-Compiler-Programs'!

!FollowLineExample class methodsFor: 'definition' stamp: 'Richo 6/21/2011 14:57'!
instanceVariableTypes
"This method was autogenerated. Do not change unless you *really* know what you're doing"
^ #(#CLong)! !

!FollowLineExample methodsFor: 'as yet unclassified' stamp: 'Richo 6/22/2011 16:24'!
isOnBlack
	<returnType: #(CBoolean)>
	^ (self sensorValue: 0) < (black + 10)! !

!FollowLineExample methodsFor: 'as yet unclassified' stamp: 'Richo 6/22/2011 16:24'!
isOnWhite
	<returnType: #(CBoolean)>
	^ self isOnBlack not! !

!FollowLineExample methodsFor: 'as yet unclassified' stamp: 'Richo 2/22/2011 13:07'!
main
	"Configure sensor"
	self setSensorLight: 0 active: true.
	
	"Get 100 samples in a second and use average as black value"
	black := 0.
	100 timesRepeat: [black := black + (self sensorValue: 0). self wait: 10].
	black := black / 100.
	
	[true] whileTrue: [
		self turnLeft.
		[self isOnWhite] whileTrue. "Wait until black"
		[self isOnBlack] whileTrue. "Wait until white"
		self turnRight.
		[self isOnWhite] whileTrue. "Wait until black"
		[self isOnBlack] whileTrue. "Wait until white"
	]! !

!FollowLineExample methodsFor: 'as yet unclassified' stamp: 'Richo 2/22/2011 13:08'!
turnLeft
	self onFwd: 0 speed: 100;
		onFwd: 2 speed: 25! !

!FollowLineExample methodsFor: 'as yet unclassified' stamp: 'Richo 2/22/2011 13:08'!
turnRight
	self onFwd: 2 speed: 100;
		onFwd: 0 speed: 25! !

!NXProgram class methodsFor: 'definition' stamp: 'Richo 1/10/2012 13:51'!
allIncludes
	^ self includesUpTo: NXProgram! !

!NXProgram class methodsFor: 'translating' stamp: 'Richo 10/13/2011 17:37'!
translatedToNxc
	"Useful method to easily translate a program to nxc. By default the class name is used as program name"
	^ self translatedToNxc: #main! !

!NXProgram class methodsFor: 'translating' stamp: 'Richo 10/13/2011 17:37'!
translatedToNxc: mainSelector 
	"Useful method to easily translate a program to nxc"
	^ self translatedToNxc: mainSelector named: self name! !

!NXProgram class methodsFor: 'translating' stamp: 'Richo 10/13/2011 17:38'!
translatedToNxc: mainSelector named: programName 
	"Useful method to easily translate a program to nxc"
	^ NxcProgramTranslator translate: mainSelector of: self asProgramNamed: programName! !

!NXProgram methodsFor: 'primitives-buttons' stamp: 'Richo 6/22/2011 16:24'!
buttonPressed: arg1 
<returnType: #(CBoolean)>
<c: 'ButtonPressed({1}, false)'>! !

!NXProgram methodsFor: 'primitives-display' stamp: 'Richo 6/21/2011 14:23'!
clearScreen 
<c: 'ClearScreen()'>! !

!NXProgram methodsFor: 'primitives-command' stamp: 'Richo 6/22/2011 16:24'!
currentTick 
<returnType: #(CUnsignedLong)>
<c: 'CurrentTick()'>! !

!NXProgram methodsFor: 'primitives-display' stamp: 'Richo 6/21/2011 14:23'!
displayNumber: arg1 x: arg2 y: arg3 
<c: 'NumOut({2}, {3}, {1})'>! !

!NXProgram methodsFor: 'primitives-display' stamp: 'Richo 6/21/2011 14:23'!
displayNumber: arg1 x: arg2 y: arg3 options: arg4 
<c: 'NumOut({2}, {3}, {1}, {4})'>! !

!NXProgram methodsFor: 'primitives-display' stamp: 'Richo 6/21/2011 14:23'!
displayText: arg1 x: arg2 y: arg3 
<c: 'TextOut({2}, {3}, {1})'>! !

!NXProgram methodsFor: 'primitives-output' stamp: 'Richo 6/21/2011 14:23'!
float: arg1 
<c: 'Float({1})'>! !

!NXProgram methodsFor: 'nxc-abstract' stamp: 'Richo 2/17/2011 19:42'!
main
	self subclassResponsibility! !

!NXProgram methodsFor: 'primitives-output' stamp: 'Richo 6/22/2011 16:24'!
motorPower: arg1 
<returnType: #(CLong)>
<c: 'MotorPower({1})'>! !

!NXProgram methodsFor: 'primitives-output' stamp: 'Richo 6/22/2011 16:24'!
motorSpeed: arg1 
<returnType: #(CLong)>
<c: 'MotorActualSpeed({1})'>! !

!NXProgram methodsFor: 'primitives-nxc' stamp: 'Richo 10/24/2011 14:20'!
nxc: aString
	"Inline the string in the code"
	<c>! !

!NXProgram methodsFor: 'primitives-output' stamp: 'Richo 6/21/2011 14:23'!
off: arg1 
<c: 'Off({1})'>! !

!NXProgram methodsFor: 'primitives-output' stamp: 'Richo 6/21/2011 14:24'!
onFwd: arg1 speed: arg2 
<c: 'OnFwd({1}, {2})'>! !

!NXProgram methodsFor: 'primitives-output' stamp: 'Richo 6/21/2011 14:24'!
onRev: arg1 speed: arg2 
<c: 'OnRev({1}, {2})'>! !

!NXProgram methodsFor: 'primitives-sound' stamp: 'Richo 6/21/2011 14:24'!
playFile: arg1 
<c: 'PlayFile({1})'>! !

!NXProgram methodsFor: 'primitives-sound' stamp: 'Richo 6/21/2011 14:24'!
playFile: arg1 volume: arg2 repeat: arg3 
<c: 'PlayFileEx({1}, {2}, {3})'>! !

!NXProgram methodsFor: 'primitives-sound' stamp: 'Richo 6/21/2011 14:24'!
playTone: arg1 duration: arg2 
<c: 'PlayTone({1}, {2})'>! !

!NXProgram methodsFor: 'primitives-sound' stamp: 'Richo 6/21/2011 14:24'!
playTone: arg1 duration: arg2 volume: arg3 repeat: arg4 
<c: 'PlayToneEx({1}, {2}, {3}, {4})'>! !

!NXProgram methodsFor: 'primitives-display' stamp: 'Richo 6/21/2011 14:24'!
resetScreen 
<c: 'ResetScreen()'>! !

!NXProgram methodsFor: 'primitives-output' stamp: 'Richo 6/21/2011 14:24'!
rotateMotor: arg1 speed: arg2 angle: arg3 
<c: 'RotateMotor({1}, {2}, {3})'>! !

!NXProgram methodsFor: 'primitives-input' stamp: 'Richo 6/22/2011 16:24'!
sensorBoolean: arg1 
<returnType: #(CBoolean)>
<c: 'SensorBoolean({1})'>! !

!NXProgram methodsFor: 'primitives-input' stamp: 'Richo 6/22/2011 16:24'!
sensorNormalized: arg1 
<returnType: #(CLong)>
<c: 'SensorNormalized({1})'>! !

!NXProgram methodsFor: 'primitives-input' stamp: 'Richo 6/22/2011 16:24'!
sensorRaw: arg1 
<returnType: #(CLong)>
<c: 'SensorRaw({1})'>! !

!NXProgram methodsFor: 'primitives-input' stamp: 'Richo 6/22/2011 16:24'!
sensorScaled: arg1 
<returnType: #(CLong)>
<c: 'SensorScaled({1})'>! !

!NXProgram methodsFor: 'primitives-input' stamp: 'Richo 6/22/2011 16:24'!
sensorType: arg1 
<returnType: #(CLong)>
<c: 'SensorType({1})'>! !

!NXProgram methodsFor: 'primitives-input' stamp: 'Richo 6/22/2011 16:25'!
sensorUS: arg1 
<returnType: #(CLong)>
<c: 'SensorUS({1})'>! !

!NXProgram methodsFor: 'primitives-input' stamp: 'Richo 6/22/2011 16:25'!
sensorValue: arg1 
<returnType: #(CLong)>
<c: 'SensorValue({1})'>! !

!NXProgram methodsFor: 'primitives-input' stamp: 'Richo 6/21/2011 14:24'!
setSensorLight: arg1 
<c: 'SetSensorLight({1})'>! !

!NXProgram methodsFor: 'primitives-input' stamp: 'Richo 6/21/2011 14:24'!
setSensorLight: arg1 active: arg2 
<c: 'SetSensorLight({1}, {2})'>! !

!NXProgram methodsFor: 'primitives-input' stamp: 'Richo 6/21/2011 14:24'!
setSensorLowSpeed: arg1 
<c: 'SetSensorLowspeed({1})'>! !

!NXProgram methodsFor: 'primitives-input' stamp: 'Richo 6/21/2011 14:24'!
setSensorLowSpeed: arg1 isPowered: arg2 
<c: 'SetSensorLowspeed({1}, {2})'>! !

!NXProgram methodsFor: 'primitives-input' stamp: 'Richo 6/21/2011 14:24'!
setSensorSound: arg1 
<c: 'SetSensorSound({1})'>! !

!NXProgram methodsFor: 'primitives-input' stamp: 'Richo 6/21/2011 14:24'!
setSensorSound: arg1 scaling: arg2 
<c: 'SetSensorSound({1}, {2})'>! !

!NXProgram methodsFor: 'primitives-input' stamp: 'Richo 6/21/2011 14:24'!
setSensorTouch: arg1 
<c: 'SetSensorTouch({1})'>! !

!NXProgram methodsFor: 'primitives-tasks' stamp: 'Richo 10/20/2011 14:43'!
start: taskName
	<argTypes: #(CString)>
	<startTask>! !

!NXProgram methodsFor: 'primitives-sound' stamp: 'Richo 6/21/2011 14:24'!
stopSound 
<c: 'StopSound()'>! !

!NXProgram methodsFor: 'primitives-command' stamp: 'Richo 6/21/2011 14:24'!
wait: arg1 
<c: 'Wait({1})'>! !

NXProgram subclass: #NXProgramTest1
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-Compiler-Programs'!

!NXProgramTest1 methodsFor: 'as yet unclassified' stamp: 'Richo 2/17/2011 19:42'!
main
	self displayNumber: 42 x: 0 y: 0.
	self prueba; prueba2; prueba2; prueba2! !

!NXProgramTest1 methodsFor: 'as yet unclassified' stamp: 'Richo 2/9/2011 10:54'!
prueba
	self displayNumber: 7 x: 0 y: 0! !

!NXProgramTest1 methodsFor: 'as yet unclassified' stamp: 'Richo 2/17/2011 19:45'!
prueba2
	<inlined>
	self displayNumber: 7 x: 0 y: 0; prueba.! !

NXProgram subclass: #NXProgramTest10
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-Compiler-Programs'!

!NXProgramTest10 methodsFor: 'as yet unclassified' stamp: 'Richo 2/21/2011 15:59'!
main
	self displayNumber: 90.51216 truncated x: 0 y: 0.
	101.45 floor.
	self wait: 2000! !

NXProgram subclass: #NXProgramTest11
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-Compiler-Programs'!

!NXProgramTest11 methodsFor: 'as yet unclassified' stamp: 'Richo 2/22/2011 18:26'!
main
	(5 isDivisibleBy: 2)
		ifTrue: [self displayText: 'True' x: 0 y: 0].
	6 \\ 2 = 0 ifTrue: [self wait: 500].

	self clearScreen.
	self displayNumber: 1092 rounded x: 0 y: 0;
		 displayNumber: 1092.015 rounded x: 0 y: 0;
		 displayNumber: 1092 rounded x: 0 y: 0.
	self wait: 2000.

	self clearScreen.
	self displayNumber: 90.0 sin x: 0 y: 0.
	self wait: 2000.! !

NXProgram subclass: #NXProgramTest12
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-Compiler-Programs'!

!NXProgramTest12 methodsFor: 'as yet unclassified' stamp: 'Richo 10/20/2011 14:28'!
main
	self start: #task1! !

!NXProgramTest12 methodsFor: 'as yet unclassified' stamp: 'Richo 3/2/2012 17:41'!
task1
	<task>
	self nxc: '3 + 4;'! !

NXProgram subclass: #NXProgramTest2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-Compiler-Programs'!

!NXProgramTest2 methodsFor: 'as yet unclassified' stamp: 'Richo 2/10/2011 11:57'!
main
	self displayText: 'Richo capo' x: 10 y: 10;
		playFile: 'Woops.rso';
		turnLeft; turnRight! !

!NXProgramTest2 methodsFor: 'as yet unclassified' stamp: 'Richo 2/9/2011 13:00'!
turnLeft
<inlined>
self
		onFwd: 0 speed: 100;
		off: 2! !

!NXProgramTest2 methodsFor: 'as yet unclassified' stamp: 'Richo 2/9/2011 13:00'!
turnRight
<inlined>
self
		onFwd: 1 speed: 100;
		off: 0! !

NXProgram subclass: #NXProgramTest3
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-Compiler-Programs'!

!NXProgramTest3 methodsFor: 'as yet unclassified' stamp: 'Richo 2/21/2011 16:23'!
main
	self displayNumber: 3 + 4 x: 0 y: 0! !

NXProgram subclass: #NXProgramTest4
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-Compiler-Programs'!

!NXProgramTest4 methodsFor: 'as yet unclassified' stamp: 'Richo 2/9/2011 17:48'!
main
	true ifTrue: [self off: 0].
	true ifFalse: [self off: 1].
	false ifTrue: [self off: 1] ifFalse: [self off: 0].
	false ifFalse: [self off: 2] ifTrue: [self off: 1]! !

NXProgram subclass: #NXProgramTest5
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-Compiler-Programs'!

!NXProgramTest5 methodsFor: 'as yet unclassified' stamp: 'Richo 2/11/2011 13:17'!
main
	4 = 3 ifTrue: [self off: 0; off: 1].
	true not ifFalse: [self off: 1].
	false not not ifTrue: [self off: 1] ifFalse: [self off: 0].
	4 > (5 * 2) ifFalse: [self off: 2] ifTrue: [self off: 1]! !

NXProgram subclass: #NXProgramTest6
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-Compiler-Programs'!

!NXProgramTest6 methodsFor: 'as yet unclassified' stamp: 'Richo 6/21/2011 15:44'!
main
	<tempTypes: #(CLong)>
	| a |
	a := 2.
	self displayNumber: a * 2 x: 0 y: 0.
	self wait: 1000.
	[] repeat.! !

NXProgram subclass: #NXProgramTest7
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-Compiler-Programs'!

!NXProgramTest7 methodsFor: 'as yet unclassified' stamp: 'Richo 6/22/2011 16:25'!
bar: aNumber
	<argTypes: #(CLong)>
	<returnType: #(CLong)>
	^ 60 atRandom! !

!NXProgramTest7 methodsFor: 'as yet unclassified' stamp: 'Richo 6/22/2011 16:25'!
foo
	<returnType: #(CLong)>
	^ 5! !

!NXProgramTest7 methodsFor: 'as yet unclassified' stamp: 'Richo 2/17/2011 18:38'!
main
	self displayNumber: (self foo) x: (self bar: 7) y: (self bar: 0);
		wait: 1000.! !

NXProgram subclass: #NXProgramTest8
	instanceVariableNames: 'var1'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-Compiler-Programs'!

!NXProgramTest8 class methodsFor: 'definition' stamp: 'Richo 6/21/2011 15:46'!
instanceVariableTypes
"This method was autogenerated. Do not change unless you *really* know what you're doing"
^ #(#CString)! !

!NXProgramTest8 methodsFor: 'as yet unclassified' stamp: 'Richo 2/18/2011 13:49'!
main
	var1 := 'Richo'.
	var1 := var1 , ' ', 'Capo'.
	self wait: 2000! !

NXProgram subclass: #NXProgramTest9
	instanceVariableNames: 'var1 var2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-Compiler-Programs'!

!NXProgramTest9 class methodsFor: 'definition' stamp: 'Richo 6/21/2011 15:46'!
instanceVariableTypes
"This method was autogenerated. Do not change unless you *really* know what you're doing"
^ #(#CString #CLong)! !

!NXProgramTest9 methodsFor: 'as yet unclassified' stamp: 'Richo 6/22/2011 16:25'!
foo
	<returnType: #(CLong)>
	^ var2! !

!NXProgramTest9 methodsFor: 'as yet unclassified' stamp: 'Richo 2/18/2011 15:50'!
main
	var1 := 'Richo'.
	var2 := 5 * 2 * 100.
	self displayText: var1 x: 0 y: 0.
	self wait: self foo! !

CTranslatedProgram subclass: #NxcTranslatedProgram
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-Compiler-Output'!

!NxcTranslatedProgram methodsFor: 'compiling' stamp: 'Richo 2/22/2011 12:07'!
compileInFileNamed: fileName
	^ NxcCompiler new program: self; compileInFileNamed: fileName! !

!NxcTranslatedProgram methodsFor: 'compiling' stamp: 'Richo 2/22/2011 12:07'!
downloadUsingBluetooth: portName
	^ NxcCompiler new program: self; downloadUsingBluetooth: portName ! !

!NxcTranslatedProgram methodsFor: 'compiling' stamp: 'Richo 2/22/2011 12:07'!
downloadUsingUsb
	^ NxcCompiler new program: self; downloadUsingUsb! !

!NxcTranslatedProgram methodsFor: 'accessing' stamp: 'Richo 6/30/2011 12:36'!
header
	^ self shouldNotImplement! !

!NxcTranslatedProgram methodsFor: 'accessing' stamp: 'Richo 7/29/2011 17:08'!
mainDeclaration
	^ 'task main();'! !

!NxcTranslatedProgram methodsFor: 'accessing' stamp: 'Richo 10/13/2011 17:43'!
mainImplementation
	"I was having trouble to access self within tasks (because tasks don't accept parameters) so I decided, in order to make this work, to use a global 'self' instead of sending it in the first parameter all the time. It really sucks because it is very limited, but it will work for Etoys. So, for now, I'll keep this approach...

-Richo (29/7/2011): "
	^'{1} self;
task main()
\{
{2}();
\}' format: {
	self mainMethod ownerClass asCString.
	self mainMethod name}

! !

!NxcTranslatedProgram methodsFor: 'printing' stamp: 'Richo 6/21/2011 17:26'!
printOn: aStream
	aStream nextPutAll: self source! !

!NxcTranslatedProgram methodsFor: 'accessing' stamp: 'Richo 3/2/2012 16:29'!
source
	"Store program's name"
	| source |
	source := WriteStream on: ''.
	source nextPutAll: '/* ', programName, ' */'; cr; cr.

	"Store structs definitions"
	structs do: [:struct |
		source nextPutAll: struct source; cr.
	].
	source cr.

	"Store methods' declarations"
	source nextPutAll: self mainDeclaration; cr.
	self methods do: [:method |
			source nextPutAll: method declaration; cr.
		].
	source cr.

	"Store methods implementation"
	source nextPutAll: self mainImplementation; cr; cr.
	self methods do: [:method |
			source nextPutAll: method source]
			separatedBy: [source cr; cr].

	^ CFormatter format: source contents! !

!NxcTranslatedProgram methodsFor: 'compiling' stamp: 'Richo 2/22/2011 12:07'!
verify
	^ NxcCompiler new program: self; verify! !

CProgramTranslator subclass: #NxcProgramTranslator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-Compiler-Translators'!

!NxcProgramTranslator commentStamp: 'Richo 2/22/2011 12:34' prior: 0!
A NxcProgramTranslator is responsible for translating a subclass of NXProgram from smalltalk to Nxc. It's public protocol is very simple, just use #translate:asProgramNamed:, which returns an instance of NxcTranslatedProgram.
An even easier way of translating programs is sending #translatedToNxc to a NXProgram subclass. For example:

	FollowLineExample translatedToNxc.
	
You can also specify a different program name:

	FollowLineExample translatedToNxc: 'Other program name'.

The translation is done recursively, starting from the #main method and translating every method call found from there. For more information, see NxcMethodTranslator comment.


Instance Variables
	program:		<NxcTranslatedProgram>

program
	- The program being translated.
!

!NxcProgramTranslator class methodsFor: 'output builder' stamp: 'Richo 10/13/2011 17:15'!
kit
	^ NxcKit! !

!NxcProgramTranslator methodsFor: 'accessing' stamp: 'Richo 7/27/2011 19:33'!
methodTranslator
	"Override if you want to define a specific method translator"
	^ NxcMethodTranslator! !

CTranslatedStruct subclass: #NxcTranslatedStruct
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-Compiler-Output'!

!NxcTranslatedStruct methodsFor: 'as yet unclassified' stamp: 'Richo 10/13/2011 17:36'!
source
	^ String streamContents: [:source |
		source nextPutAll: 'struct ', ownerClass asCString, ' {'; cr.
		variables do: [:var |
			source nextPutAll: var source; nextPut: $;; cr].
		source nextPutAll: '};'
		]! !

CMethodTranslator subclass: #NxcMethodTranslator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-Compiler-Translators'!

!NxcMethodTranslator methodsFor: 'as yet unclassified' stamp: 'Richo 10/24/2011 14:21'!
acceptMessageNode: aMessageNode
	| method receiverClass |
	receiverClass := self findClassOf: aMessageNode receiver.
	method := receiverClass ultimateCompiledMethodAt: aMessageNode selector ifAbsent: [self error: 'Method not found'].

	(method pragmaAt: #startTask)
		ifNotNil: [:pragma | 
			(CMethodToImplement
				class: receiverClass
				selector: aMessageNode arguments first value)
				signal.
			self storeStartTask: aMessageNode.
			^ self].	

	super acceptMessageNode: aMessageNode! !

!NxcMethodTranslator methodsFor: 'as yet unclassified' stamp: 'Richo 7/29/2011 17:22'!
acceptMethodNode: aMethodNode
	"Overriden to make sure we don't add a 'return self' at the end of a task"
	self visitNode: aMethodNode body.
	aMethodNode lastIsReturn
		ifFalse: [aMethodNode pragmas 
			detect: [:each | each selector = #task]
			ifNone: [self visitNode: self selfReturn]]! !

!NxcMethodTranslator methodsFor: 'as yet unclassified' stamp: 'Richo 10/24/2011 11:49'!
acceptVariableNode: aVariableNode

	"Is it an inst var?"
	((class instVarNamesUpTo: CObject) includes: aVariableNode name)
		ifTrue: [self signalInstVarToImplement: aVariableNode.
			source nextPutAll: 'self.'].		

	source nextPutAll: aVariableNode name.! !

!NxcMethodTranslator methodsFor: 'as yet unclassified' stamp: 'Richo 10/14/2011 14:52'!
argVarsOf: methodNode
	"The first argument always is the receiver, but in Nxc we use a global 'self', so we don't need to send it all the time."
	^ (super argVarsOf: methodNode) allButFirst! !

!NxcMethodTranslator methodsFor: 'as yet unclassified' stamp: 'Richo 10/20/2011 14:46'!
storeRegularMessageSend: aMessageNode
	source nextPutAll: (self findTypeOf: aMessageNode receiver) name, aMessageNode selector asCIdentifier, '('.
	aMessageNode arguments
		do: [:each | self visitNode: each]
		separatedBy: [source nextPutAll: ', '].
	source nextPut: $)! !

!NxcMethodTranslator methodsFor: 'as yet unclassified' stamp: 'Richo 10/20/2011 14:44'!
storeStartTask: aMessageNode
	source nextPutAll: 'StartTask(';
			nextPutAll: (self findTypeOf: aMessageNode receiver) name;
			nextPutAll: aMessageNode arguments first value asCIdentifier;
			nextPutAll: ')'! !

CTranslatedVariable subclass: #NxcTranslatedVariable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-Compiler-Output'!

!NxcTranslatedVariable methodsFor: 'as yet unclassified' stamp: 'Richo 10/13/2011 17:36'!
source
	^ self type source, ' ', self name! !

!RBConfigurableFormatter methodsFor: '*squeaknxt-compiler' stamp: 'Richo 1/5/2011 10:35'!
acceptPragmaNode: aPragmaNode
	"Fixed to parse pragmas correctly"
	codeStream nextPut: $<.
	self 
		formatSelectorAndArguments: aPragmaNode 
		firstSeparator: [ 
			aPragmaNode isBinary
				ifTrue: [ self space ] ]
		restSeparator: [ self space ].
	codeStream nextPut: $>! !

Object subclass: #Nbc
	instanceVariableNames: 'parameters'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-Compiler-Api'!

!Nbc commentStamp: '<historical>' prior: 0!
A Nbc is a very simple API for accessing the Next Byte Codes Compiler using FFI on Windows. This class requires the actual nbc program installed in the default directory. You can download it from here "http://http://bricxcc.sourceforge.net/nbc/". FYI, I'm using the version 1.2.1.r3 (2010-06-29).

Examples: 
1) The simplest example would be compiling into a file called "output" and reporting errors to a file called "errors":

	Nbc forThisPlatform
		fileName: 'example_program.nbc';
		outFile: 'output';
		errorsFile: 'errors';
		execute.
		
2) To download a program into the Lego Nxt using the usb:

	Nbc forThisPlatform
		fileName: 'example_program.nbc';
		portName: 'usb';
		downloadProgram;
		execute.
		
3) To use the bluetooth on COM6 instead:
	
	Nbc forThisPlatform
		fileName: 'example_program.nbc';
		useBluetooth;
		portName: 'COM6';
		downloadProgram;
		execute.

Instance Variables
	parameters:		<WriteStream>

parameters
	- Used to build the parameters string to be sent to the nbc program. See "nbc -help" for more information.
!

!Nbc class methodsFor: 'instance creation' stamp: 'Richo 3/18/2012 16:49'!
forThisPlatform
	(self allSubclasses 
		detect: [:each | each platformName = SmalltalkImage current platformName]
		ifNone: [nil])
			ifNil: [^ self error: SmalltalkImage current platformName, 
								' - Platform not supported' translated]
			ifNotNil: [:actualClass |
				^ actualClass basicNew initialize]! !

!Nbc class methodsFor: 'instance creation' stamp: 'Richo 3/18/2012 16:50'!
new
	"Use #forThisPlatform instead"
	^ self shouldNotImplement! !

!Nbc class methodsFor: 'instance creation' stamp: 'Richo 3/18/2012 16:51'!
platformName
	^ self subclassResponsibility! !

!Nbc methodsFor: 'accessing' stamp: 'Richo 12/25/2010 00:45'!
beQuiet
	parameters space; nextPutAll: '-q'! !

!Nbc methodsFor: 'accessing' stamp: 'Richo 12/25/2010 00:45'!
decompileProgram
	parameters space; nextPutAll: '-x'! !

!Nbc methodsFor: 'accessing' stamp: 'Richo 12/25/2010 00:45'!
defineMacro: aByteString 
	parameters space; nextPutAll: '-D='; nextPutAll: aByteString ! !

!Nbc methodsFor: 'accessing' stamp: 'Richo 12/25/2010 00:45'!
dontCompile
	parameters space; nextPutAll: '-b'! !

!Nbc methodsFor: 'accessing' stamp: 'Richo 12/25/2010 00:45'!
dontIncludeSystemFile
	parameters space; nextPutAll: '-n'! !

!Nbc methodsFor: 'accessing' stamp: 'Richo 12/25/2010 00:46'!
downloadProgram
	parameters space; nextPutAll: '-d'! !

!Nbc methodsFor: 'accessing' stamp: 'Richo 12/28/2010 18:25'!
enhancedFirmware
	parameters space; nextPutAll: '-EF'! !

!Nbc methodsFor: 'accessing' stamp: 'Richo 12/25/2010 00:46'!
errorsFile: aByteString 
	parameters space; nextPutAll: '-E='; nextPutAll: aByteString ! !

!Nbc methodsFor: 'executing' stamp: 'Richo 3/18/2012 16:52'!
execute
	self subclassResponsibility! !

!Nbc methodsFor: 'accessing' stamp: 'Richo 12/25/2010 00:46'!
fileName: aByteString 
	parameters space; nextPutAll: aByteString! !

!Nbc methodsFor: 'accessing' stamp: 'Richo 12/25/2010 00:47'!
includePath: aByteString 
	parameters space; nextPutAll: '-I='; nextPutAll: aByteString ! !

!Nbc methodsFor: 'initialize' stamp: 'Richo 12/25/2010 00:44'!
initialize
	super initialize.
	parameters := WriteStream on: ''! !

!Nbc methodsFor: 'accessing' stamp: 'Richo 12/29/2010 17:59'!
nbc: fileName
	parameters space; nextPutAll: '-nbc='; nextPutAll: fileName! !

!Nbc methodsFor: 'accessing' stamp: 'Richo 1/3/2011 14:07'!
optimizationLevel: number
	parameters space; nextPutAll: '-Z'; nextPutAll: number asString! !

!Nbc methodsFor: 'accessing' stamp: 'Richo 12/25/2010 00:47'!
outFile: aByteString 
	parameters space; nextPutAll: '-O='; nextPutAll: aByteString ! !

!Nbc methodsFor: 'accessing' stamp: 'Richo 12/25/2010 00:47'!
portName: aByteString 
	parameters space; nextPutAll: '-S='; nextPutAll: aByteString ! !

!Nbc methodsFor: 'accessing' stamp: 'Richo 12/25/2010 00:48'!
useBluetooth
	parameters space; nextPutAll: '-BT'! !

!Nbc methodsFor: 'accessing' stamp: 'Richo 12/28/2010 18:38'!
warningsOn
	parameters space; nextPutAll: '-w'! !

Nbc subclass: #UnixNbc
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-Compiler-Api'!

!UnixNbc class methodsFor: 'as yet unclassified' stamp: 'Richo 3/18/2012 16:51'!
platformName
	^ 'unix'! !

!UnixNbc methodsFor: 'as yet unclassified' stamp: 'Richo 3/18/2012 16:56'!
changeCurrentDirectoryOf: osProcess to: pathString
	"Change current directory. We can't send #chDir: directly to osProcess
	because if it fails it shows an annoying error message to the user"
	| realPath result |
	realPath := osProcess processAccessor realpath: pathString.
	realPath ifNil: [realPath := pathString].
	result := osProcess processAccessor chDir: realPath.
	result isNil
		ifTrue:
			[(osProcess environmentAt: #PWD)
				ifNotNil:
					[osProcess environmentAt: #PWD put: realPath]]
		ifFalse: ["log message"].! !

!UnixNbc methodsFor: 'as yet unclassified' stamp: 'Richo 3/18/2012 16:57'!
execute
	"Executes the command using OSProcess"
	| osProcess |
	osProcess := (Smalltalk
				at: #OSProcess
				ifAbsent: [^ self error: 'OSProcess not installed' translated]) thisOSProcess.
	self changeCurrentDirectoryOf: osProcess to: SmalltalkImage current imagePath.
	osProcess command: './nbc ' , parameters contents! !

Nbc subclass: #Win32Nbc
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-Compiler-Api'!

!Win32Nbc class methodsFor: 'as yet unclassified' stamp: 'Richo 3/18/2012 16:51'!
platformName
	^ 'Win32'! !

!Win32Nbc methodsFor: 'as yet unclassified' stamp: 'Richo 3/18/2012 16:52'!
execute
	"Executes the command using FFI"
	| result shell |
	shell := Smalltalk at: #Win32Shell ifAbsent: [^self error: 'FFI doesn''t seem to be installed'].
	((result := shell new 
		shellExecute: nil
		lpOperation:  'open'
		lpFile: 'nbc.exe'
		lpParameters: parameters contents
		lpDirectory: nil
		nShowCmd: 1) <= 32) ifTrue: [self error: 'system error, code: ', result]! !

Object subclass: #NxcCompiler
	instanceVariableNames: 'programName source'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-Compiler-Api'!

!NxcCompiler commentStamp: 'Richo 12/31/2010 22:03' prior: 0!
A NxcCompiler is responsible for verifying/compiling programs as well as downloading them to the LegoNxt.

===============================
	"Code example"
	
	| program |
	
	"A simple nxc program"
	program := '
	#define MOVE_TIME   1000
	#define TURN_TIME    500

	task main()
	{
		repeat(4)
		{    
			OnFwd(OUT_AC, 75);
			Wait(MOVE_TIME);
			OnRev(OUT_C, 75);
		Wait(TURN_TIME);
		}  
		Off(OUT_AC);
	}'.
	
	"The code below will verify the program and return a collection of errors (if any)"
	NxcCompiler new
		source: program;
		verify.
	
	"The code below will download the program to the nxt using the usb cable. the resulting program will be called 'SimpleProgram'"
	NxcCompiler new
		programName: 'SimpleProgram';
		source: program;
		downloadUsingUsb.
===============================

Instance Variables
	programName:		<String>
	source:		<String>

programName
	- A name for the program. If not specified the program name will be the NxcCompiler instance's hash (not a nice name for a program, I must say).

source
	- The nxc source code of the program.
!

!NxcCompiler methodsFor: 'compiling' stamp: 'Richo 3/18/2012 17:00'!
compileInFileNamed: outFile
	"Compiles the program into a file"
	^ self execute: (Nbc forThisPlatform outFile: outFile)! !

!NxcCompiler methodsFor: 'compiling' stamp: 'Richo 3/18/2012 17:00'!
downloadUsingBluetooth: portName 
	"Compiles the program and downloads it using the bluetooth on the specified port name (COMn). Returns a collection of NbcErrors"
	^ self execute: (Nbc forThisPlatform portName: portName; useBluetooth; downloadProgram)! !

!NxcCompiler methodsFor: 'compiling' stamp: 'Richo 3/18/2012 17:00'!
downloadUsingUsb
	"Compiles the program and downloads it using the usb cable. Returns a collection of NbcErrors"
	^ self execute: (Nbc forThisPlatform portName: 'usb'; downloadProgram)! !

!NxcCompiler methodsFor: 'private' stamp: 'Richo 12/27/2010 18:14'!
errorsFileName
	"Temporary file name to store errors during compilation"
	^ self programName , '.err'! !

!NxcCompiler methodsFor: 'private' stamp: 'Richo 1/3/2011 14:07'!
execute: nbc 
	"Create the temporary files to store the source code and the errors.
	Execute nbc.
	Wait until nbc finishes and parse errors.
	Delete temporary files.
	Return errors"
	source isNil ifTrue: [^ self error: 'Source cannot be nil'].
	FileStream forceNewFileNamed: self programFileName do: [:file | file nextPutAll: source]; 
				forceNewFileNamed: self errorsFileName do: [:file | "Do nothing. Nbc will write this file"].
	[nbc fileName: self programFileName;
		 errorsFile: self errorsFileName;
		 optimizationLevel: 2;
		 execute.
	^ self parseErrors]
		ensure: [FileDirectory default deleteFileNamed: self programFileName;
				 deleteFileNamed: self errorsFileName]! !

!NxcCompiler methodsFor: 'private' stamp: 'Richo 1/4/2011 15:33'!
parse: errorsFile
"Returns a collection with all the errors founded by the nbc compiler. The errorsFile format is similar to this:

# Error: Unknown or invalid statement
File ""D:\RICHI\Squeak images\Nxt\simpleprogram.nbc"" ; line 7
#   result sbyt
#----------------------------------------------------------
1 error during compilation
"
| errors |
errors := OrderedCollection new.
[errorsFile peek = $#] 
	whileTrue: [ | errorDescription errorPosition errorSource |
		errorDescription := errorsFile nextLine allButFirst: 2.
		errorPosition := (errorsFile nextLine subStrings: {$;}) last withBlanksTrimmed.
		errorSource := errorsFile nextLine allButFirst: 4.
		errorsFile nextLine.
		errors add: (NxcError description: errorDescription position: errorPosition source: errorSource).
		].
^errors asArray! !

!NxcCompiler methodsFor: 'private' stamp: 'Richo 1/4/2011 23:37'!
parseErrors
	"Wait until the errors file is fully written by nbc, then read it and return the errors.
	IMPORTANT: Be aware that this code relies on the fact that FileStream>>#fileNamed: returns nil when the file is being modified by another process. If this somehow changes in the future, this code will inevitably break."
	| errorsFile |
	[200 milliSeconds asDelay wait.
	(errorsFile := FileStream fileNamed: self errorsFileName) isNil] whileTrue.
	[^ self parse: errorsFile]
		ensure: [errorsFile close].
! !

!NxcCompiler methodsFor: 'accessing' stamp: 'Richo 7/27/2011 18:49'!
program: aNxcProgram
	source := aNxcProgram source.
	programName isNil ifTrue: [programName := aNxcProgram name]! !

!NxcCompiler methodsFor: 'private' stamp: 'Richo 12/29/2010 17:43'!
programFileName
	"Temporary file name to store the source code"
	^ self programName , '.nxc'! !

!NxcCompiler methodsFor: 'accessing' stamp: 'Richo 12/27/2010 22:10'!
programName
	"If programName is not specified, the default name will be this instance's hash"
	^ programName ifNil: [self hash asString]! !

!NxcCompiler methodsFor: 'accessing' stamp: 'Richo 12/27/2010 16:47'!
programName: aString
	programName := aString! !

!NxcCompiler methodsFor: 'accessing' stamp: 'Richo 12/27/2010 17:07'!
source
	^ source! !

!NxcCompiler methodsFor: 'accessing' stamp: 'Richo 12/27/2010 16:48'!
source: aString
	source := aString.! !

!NxcCompiler methodsFor: 'compiling' stamp: 'Richo 3/18/2012 17:00'!
verify
	"Compiles the program and returns a collection of NbcErrors. If the collection is empty then the program is ok"
	^ self execute: Nbc forThisPlatform! !

Object subclass: #NxcError
	instanceVariableNames: 'description position source'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-Compiler-Api'!

!NxcError class methodsFor: 'instance creation' stamp: 'Richo 12/25/2010 16:02'!
description: description position: position source: source
^ (self basicNew setDescription: description position: position source: source) initialize ! !

!NxcError methodsFor: 'accessing' stamp: 'Richo 12/27/2010 16:01'!
description
	^ description ! !

!NxcError methodsFor: 'accessing' stamp: 'Richo 12/27/2010 16:01'!
position
	^ position ! !

!NxcError methodsFor: 'printing' stamp: 'Richo 12/27/2010 22:08'!
printOn: aStream
aStream nextPutAll: position asString;
		 nextPut: $:;
		 space;
		 nextPutAll: description asString 
! !

!NxcError methodsFor: 'private' stamp: 'Richo 12/25/2010 16:02'!
setDescription: aByteString position: aByteString2 source: aByteString3 
	description := aByteString.
	position := aByteString2.
	source := aByteString3! !

!NxcError methodsFor: 'accessing' stamp: 'Richo 12/27/2010 16:01'!
source
	^ source ! !

!RBScanner methodsFor: '*squeaknxt-compiler' stamp: 'Richo 1/11/2011 09:37'!
scanNumber
	"Changed to use Number>>#readFrom: instead of SqNumberParser>>#parse:. For Etoys compatibility"
	| start number stop string |
	start := stream position.
	stream position: start - 1.
	(Smalltalk includesKey: #SqNumberParser)
		ifTrue: [number := (Smalltalk at: #SqNumberParser) parse: stream]
		ifFalse: [number := Number readFrom: stream].
	stop := stream position.
	stream position: start - 1.
	string := stream next: stop - start + 1.
	stream position: stop.
	self step.
	^RBNumberLiteralToken 
		value: number
		start: start
		stop: stop
		source: string! !

CTranslatedFunction subclass: #NxcTranslatedFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-Compiler-Output'!

!NxcTranslatedFunction methodsFor: 'as yet unclassified' stamp: 'Richo 10/13/2011 17:21'!
declaration
	^ String streamContents: [:stream |
		self isATask
			ifTrue: [stream nextPutAll: 'task']
			ifFalse: [stream nextPutAll: 'safecall ', self returnType source].
		stream nextPutAll: ' ', self name, '('.
		self arguments
			do: [:each | stream nextPutAll: each source]
			separatedBy: [stream nextPutAll: ', '].
		stream nextPutAll: ');']! !

!NxcTranslatedFunction methodsFor: 'as yet unclassified' stamp: 'Richo 10/13/2011 17:44'!
isATask
	"To define a method as a task you should use the #task pragma"
	(ownerClass ultimateCompiledMethodAt: selector ifAbsent: [])
		ifNil: [self error: 'Method not found']
		ifNotNil: [:method |
			^ (method pragmaAt: #task) notNil]! !

CKit subclass: #NxcKit
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-Compiler-Translators'!

!NxcKit class methodsFor: 'factory' stamp: 'Richo 6/30/2011 12:30'!
functionClass
	^ NxcTranslatedFunction! !

!NxcKit class methodsFor: 'factory' stamp: 'Richo 6/28/2011 12:35'!
programClass
	^ NxcTranslatedProgram! !

!NxcKit class methodsFor: 'factory' stamp: 'Richo 6/28/2011 16:06'!
structClass 
	^ NxcTranslatedStruct! !

!NxcKit class methodsFor: 'factory' stamp: 'Richo 10/13/2011 17:45'!
typeClass 
	^ NxcType! !

!NxcKit class methodsFor: 'factory' stamp: 'Richo 7/27/2011 18:38'!
variableClass
	^ NxcTranslatedVariable! !
